#perl2exe_include "DBD/mysql.pm";

#!/usr/bin/perl -w
$|=1;

use IO::Socket;
use IO::Socket::INET;
use IO::Select;
use DBI;
use LWP::UserAgent;
use Config::IniFiles;


my $DEBUG = 0;

my $version = '$Revision: 1.00 $';
$version =~ /(\d|\.)+/;
$version = $&;

########## BEGIN Config ##########

my $cfg = Config::IniFiles->new( -file => 'bountyhunt.ini' );

my $flhook_host = $cfg->val('FLHook', 'flhook_host');
my $flhook_port = $cfg->val('FLHook', 'flhook_port');
my $flhook_pass = $cfg->val('FLHook', 'flhook_pass');

my $DatabaseHost = $cfg->val('MysqlDB', 'DatabaseHost');
my $DatabaseName = $cfg->val('MysqlDB', 'DatabaseName');
my $DatabaseUsername = $cfg->val('MysqlDB', 'DatabaseUsername');
my $DatabasePassword = $cfg->val('MysqlDB', 'DatabasePassword');
my $bountyhunt_table_name = $cfg->val('MysqlDB', 'BountyhuntTableName');
my $flsystem_table_name = $cfg->val('MysqlDB', 'FLSystemsTableName');

my $bounty_time_limit = $cfg->val('Bountyhunt', 'bounty_time_limit');
my $umsg_interval = $cfg->val('Bountyhunt', 'umsg_interval');
my $start_money = $cfg->val('Bountyhunt', 'start_money');
my $player_minimum = $cfg->val('Bountyhunt', 'player_minimum');
my $bountyblock_time = $cfg->val('Bountyhunt', 'bountyblock_time');
my $reward_increase = $cfg->val('Bountyhunt', 'reward_increase');
my $reward_interval = $cfg->val('Bountyhunt', 'reward_interval');
my $max_system_time = $cfg->val('Bountyhunt', 'max_system_time');
my $crash_timelimit = $cfg->val('Bountyhunt', 'crash_timelimit');
my $stale_timelimit = $cfg->val('Bountyhunt', 'stale_timelimit');
my $bounty_changes_limit = $cfg->val('Bountyhunt', 'bounty_changes_limit');
my $loggedin_check_interval = $cfg->val('Bountyhunt', 'loggedin_check_interval');
my $systempaths_file = $cfg->val('Bountyhunt', 'systempaths_file');

########## END Config ##########

my $dbh = undef;
my $conn = undef;
my $flhookping_timeout = 10;
my $lastcontact = time();
my $ua = LWP::UserAgent->new();
$ua->agent("Bountyhunt Manager v$version");

my $bountyhunt_hunted = undef;
my $bountyhunt_started = undef;
my %bountyhunt_last = undef;
my $bountyhunt_bounty = undef;
my $bountyhunt_changes = 0;
my $target_system = undef;
my $system_change = undef;
my $system_change_warned = undef;
my $last_umsg = undef;
my $bountyhunt_increased = undef;
my $last_loggedincheck = undef;
my $server_crashed = undef;
my $bountyhunt_stale = undef;
my $bountyhunt_stale_time = undef;
my $bountyhunt_activated = 1;
my $current_system = undef;


print "Bountyhunt Module v$version (written in Perl by w0dk4&Niwo 2006)\n";
&logger("-open socket $flhook_host:$flhook_port\n");

$SIG{'INT'}  = 'shutdownhandler';
$SIG{'TERM'} = 'shutdownhandler';

&logger("-connect db\n");
&connectdb();
&logger("-OK\n");


&connect_to_flhook();

&logger("-entering main loop, begin work\n");

while (1)
{
	
	if (!defined $bountyhunt_stale and defined $bountyhunt_started and (time() - $bountyhunt_increased) > ($reward_interval*60)) {
		if (defined $conn) {
			&increase_reward();
			send_chat("","","Bountyhunt: Reward for killing $bountyhunt_hunted has been increased to $bountyhunt_bounty Credits! ");
		}
	}
	
	if (defined $bountyhunt_started and (time() - $bountyhunt_started) > ($bounty_time_limit*60)) {
		if (defined $conn) {
			send_chat("","","Bountyhunt has been aborted. Reason: Timelimit reached! ");
		}
		&abort_bountyhunt();
	}
	
	if (defined $bountyhunt_started and defined $bountyhunt_stale and (time() - $bountyhunt_stale_time) > ($stale_timelimit*60)) {
		if (defined $conn) {
			send_chat("","","Bountyhunt has been aborted. Reason: Takeover Timelimit reached! ");
		}
		&abort_bountyhunt();
	}
	
	if (!defined $bountyhunt_stale and defined $bountyhunt_started and !defined $system_change_warned and (time() - $system_change) > (($max_system_time-3)*60)) {
		if (defined $conn) {
			send_chat($bountyhunt_hunted,"","WARNING: You have 3 minutes left to leave this system. Otherwise the Bountyhunt will be interrupted! ");
		}
		$system_change_warned = 1;
	}	
	
	if (!defined $bountyhunt_stale and defined $bountyhunt_started and !defined $server_crashed and (time() - $system_change) > ($max_system_time*60)) {
		if (defined $conn) {
#			send_chat("","","Bountyhunt has been aborted. Reason: The Hunted reached a System Timelimit! ");
		}
		&bountyhunt_stale();
	}
	
	if (!defined $bountyhunt_stale and defined $server_crashed and (time() - $server_crashed) > ($crash_timelimit*60)) {
		if (defined $conn) {
			if (!&loggedin_check()) {
				&bountyhunt_stale();
#				send_chat("","","Bountyhunt has been aborted. Reason: Server crashed and the Hunted did not reconnect! ");
			} else {
				$server_crashed = undef;
    		$system_change = time();
    		$system_change_warned = 0;
				next;
			}
		}
		&bountyhunt_stale();
	}
	
	if (!defined $bountyhunt_stale and defined $bountyhunt_started and (time() - $last_umsg) > ($umsg_interval*60)) {
		if (defined $conn) {
			my $minutes_left = round($bounty_time_limit - ((time() - $bountyhunt_started)/60));
			if ($bountyhunt_changes > 0) {
				send_chat("","","Bountyhunt:  $minutes_left minutes left to kill $bountyhunt_hunted and steal the Escape Pod to get $bountyhunt_bounty Credits! The Hunted is heading to the ".get_region($target_system)." systems.. ");
			}	else {
				send_chat("","","Bountyhunt:  $minutes_left minutes left to kill $bountyhunt_hunted and get $bountyhunt_bounty Credits! The Hunted is heading to the ".get_region($target_system)." systems.. ");
			}
		}
		$last_umsg = time();
	}
	
	
	if (!defined $bountyhunt_stale and defined $bountyhunt_started and (time() - $last_loggedincheck) > $loggedin_check_interval) {
		if (defined $conn) {
			if (!&loggedin_check()) {
#				send_chat("","","Bountyhunt has been aborted. Reason: Hunted Player left the game! ");
				&bountyhunt_stale();
			}
		}		
	}
	
	

    my $line = undef;
    if ( defined $conn ) {
        $line = <$conn>;
    }
    if ( defined $line )
    {
        while ( defined $line )
        {
            &handle($line);
            $line = <$conn>;
        }
        $lastcontact = time();
    }

    if ( (time() - $lastcontact) > 30 ) {
        if ( !&ping_flhook() )
        {
            &logger("reconnect\n");
            &connect_to_flhook();
            if (defined $bountyhunt_started) {
            	$server_crashed = time();
            }
        }
        else
        {
        #    &logger("still connected\n");
        }
        $lastcontact = time();
    }

    #20 ticks per sec
    select(undef,undef,undef,0.05);
}

sub logger
{
    my $line = shift;
    my $printdate = shift;
    $printdate = 1 if ( !defined $printdate );
    print &getdate()." " if ( $printdate );
    print $line;
}
sub logger_err
{
    my $line = shift;
    my $linenr = shift;
    my $printdate = shift;
    $printdate = 1 if ( !defined $printdate );
    print STDERR &getdate()." " if ( $printdate );
    print STDERR "(in Line $linenr) ".$line;
}

sub readWithTimeout
{
    my ($timeout,$returnstring) = @_;
    my $line= undef;
    my $starttime = time();
    while ( (time() - $starttime) < $timeout )
    {
        $line = <$conn>;
        if ( defined $line ) {
        	if ( defined $returnstring) {
        		my $match_check = $line;
        		if ($match_check =~ m/^($returnstring)(.*)$/) {
            return $line;
          	}
          } else {
           return $line;
          }
        }
        #100 ticks per sec
        select(undef,undef,undef,0.01);
    }
    return $line;
}

sub ping_flhook
{
    &logger("ping flhook\n") if $DEBUG;
    if ( defined $conn )
    {
        print $conn "ping\n";
        my $line = readWithTimeout(5);
        if (defined $line)
        {
            return 1;
        }
    }
    return 0;
}

sub shutdownhandler
{
    &logger("-disconnect db\n");
    &disconnect_flhook();
    &logger("-OK\n");
    $dbh->disconnect();
    &logger("\nshutdown complete.\n");
    exit(0);
}


sub disconnect_flhook
{
    if ( defined $conn ) {
        print $conn "quit\n";
        my $line = &readWithTimeout(1);
        if ( defined $line ) {
            chop($line);chop($line);
            if ( $line ne "Goodbye." )
            {
                &logger_err("\nError while disconnect: $line\n",__LINE__);
            }
        }
        else
        {
            &logger_err("\nError while disconnect\n",__LINE__);
        }
        close $conn;
        $conn = undef;
    }
}
sub connect_to_flhook
{
    &disconnect_flhook();

    &logger("-connect socket\n");
    $conn = IO::Socket::INET->new(PeerAddr => $flhook_host,
                                    PeerPort => $flhook_port,
                                    Proto    => "tcp",
                                    Type     => SOCK_STREAM,
                                    Timeout  => 5,
                                    Blocking => 0)
    or logger_err("Could not connect to $flhook_host:$flhook_port: $@\n",__LINE__);
    if ( defined $conn ) {
#       &nonblock($conn);
        $conn->autoflush(1);
        
        &logger("-OK\n");
        &logger("-login\n");

        my $line = &readWithTimeout(5);
        if ( defined $line )
        {
            chop($line);chop($line);

            if ( $line ne "Welcome to FLHack, please authenticate" )
            {
                &logger_err("\nError while login: $line\n",__LINE__);
            }
        }
        else
        {
            logger_err("\nError while login\n",__LINE__);
        }

        print $conn "pass $flhook_pass\n";

        $line = &readWithTimeout(5);
        if ( defined $line )
        {
            chop($line);chop($line);

            if ( $line ne "OK" )
            {
                &logger_err("\nError while login: $line\n",__LINE__);
            }
        } else {
            logger_err("\nError while login\n",__LINE__);
        }
        &logger("-$line\n");

        &logger("-starting listening\n");
        print $conn "eventmode\n";

        $line = &readWithTimeout(5);
        if ( defined $line )
        {
            chop($line);chop($line);

            if ( $line ne "OK" )
            {
                &logger_err("\nError while start eventmode: $line\n",__LINE__);
            }
        }
        else
        {
            logger_err("\nError while start eventmode\n",__LINE__);
        }
        &logger("-$line\n");
    }
}


sub connectdb
{
        if ( !$dbh )
        {
            $dbh = DBI->connect("DBI:mysql:database=$DatabaseName;host=$DatabaseHost",
                             $DatabaseUsername, $DatabasePassword,
                             {'RaiseError' => 0,
                              'mysql_connect_timeout' => 3,
                              'mysql_compression' => 1}) or die "error connecting db";
      } else {
        if ( !$dbh->ping )
        {
                $dbh = DBI->connect("DBI:mysql:database=$DatabaseName;host=$DatabaseHost",
                                 $DatabaseUsername, $DatabasePassword,
                                 {'RaiseError' => 0,
                                  'mysql_connect_timeout' => 3,
                                  'mysql_compression' => 1}) or die "error connecting db";
        }
      }
}

sub send_chat
{
  my($char,$id,$text) = @_;

  
  if ($id eq "" && $char eq "")
  {
  	chop($text);
    print $conn 'msgu '.$text."\n";
  } else {
  	
  $text =~ s/&/&#38;/g;
  $text =~ s/</&#60;/g;
  $text =~ s/>/&#62;/g;
    if ( $id ne "" )
    {
        chop($text);
        print $conn 'fmsg$ '.$id.' <TRA data="0x00FF0090" mask="-1"/><TEXT>'.$text.'</TEXT>'."\n";
      }
      elsif ( $char ne "" )
      {
        chop($text);
        print $conn 'fmsg '.$char.' <TRA data="0x00FF0090" mask="-1"/><TEXT>'.$text.'</TEXT>'."\n";
      }
  }

  #wait for ok
  my $line = &readWithTimeout(3,"OK");
  if ( defined $line )
  {
    chop($line);chop($line);
    if ( $line ne "OK" )
    {
      &logger_err("Error: no OK after chat\n",__LINE__);
    }
  } else {
    &logger_err("Error: no OK after chat\n",__LINE__);
  }
}

sub getdate {
  my ($sec,$min,$hour,$mday,$mon,$year,undef,undef,undef) = localtime(time);
  $year += 1900;
  $mon++;
  my $date = sprintf("%02d.%02d.%4d %02d:%02d:%02d",$mday,$mon,$year,$hour,$min,$sec);
  return $date;
}

sub round {
    my($number) = shift;
    return int($number + .5);
}

sub abort_bountyhunt {
	
	my $sql = "INSERT INTO $bountyhunt_table_name (hunted, bounty, outcome, changes, timestamp) VALUES ".
                      "(".$dbh->quote($bountyhunt_hunted).",".$dbh->quote($bountyhunt_bounty).",".$dbh->quote("aborted").",".$dbh->quote($bountyhunt_changes).",CURRENT_TIMESTAMP)";
  $dbh->do($sql);
	
$bountyhunt_hunted = undef;
$bountyhunt_started = undef;
$bountyhunt_bounty = undef;
$target_system = undef;
$system_change = undef;
$system_change_warned = undef;
$last_umsg = undef;
$bountyhunt_increased = undef;
$last_loggedincheck = undef;
$bountyhunt_changes = 0;
$server_crashed = undef;
$bountyhunt_stale = undef;
	
}

sub increase_reward {
	
	my $players_on = get_players_on();
	my $bounty_increase = $players_on * $reward_increase;
	
	$bountyhunt_bounty = $bountyhunt_bounty + $bounty_increase;
	
	$bountyhunt_increased = time();
	
}

sub loggedin_check {
	
	print $conn "isloggedin $bountyhunt_hunted\n";
	my $line = &readWithTimeout(2,"loggedin=");
	if (!defined $server_crashed and $line=~ m/loggedin=no/) {
		return 0;
	} else {
		$last_loggedincheck = time();
		return 1;
	}
	
}

sub end_bountyhunt {
	my ($killer) = @_;
	
		print $conn "addcash $bountyhunt_hunted $bountyhunt_bounty\n";
		my $spamline = &readWithTimeout(2,"OK");
		my $sql = "INSERT INTO $bountyhunt_table_name (hunted, bounty, outcome, changes, timestamp) VALUES ".
                      "(".$dbh->quote($bountyhunt_hunted).",".$dbh->quote($bountyhunt_bounty).",".$dbh->quote("finished").",".$dbh->quote($bountyhunt_changes).",CURRENT_TIMESTAMP)";
    $dbh->do($sql);
	
	
$bountyhunt_hunted = undef;
$bountyhunt_started = undef;
$bountyhunt_bounty = undef;
$target_system = undef;
$system_change = undef;
$system_change_warned = undef;
$last_umsg = undef;
$bountyhunt_increased = undef;
$last_loggedincheck = undef;	
$bountyhunt_changes = 0;
$server_crashed = undef;

}

sub change_bountyhunt {
	my ($new_hunted) = @_;
	
	if ($bountyhunt_changes < $bounty_changes_limit) {
		send_chat($new_hunted,"","To get the money dock at any base in the ".get_sys_readable($target_system)." System to deliver the Escape Pod! ");
		$bountyhunt_hunted = $new_hunted;
		$bountyhunt_changes++;
		$system_change = time();
    $system_change_warned = 0;
	} else {
		send_chat("","","Bountyhunt has been aborted. Reason: The Client is tired of this! ");
		&abort_bountyhunt();
	}
	
}

sub start_bountyhunt {
	my ($from,$id,$startbounty) = @_;
	
	## check if player can start new bounty
	if (defined $bountyhunt_last and (time() - $bountyhunt_last) < ($bountyblock_time*60*60) ) {
		send_chat($from,$id,"You may not start a new bounty within $bountyblock_time hours! ");
	} else {
		my $players_online = get_players_on();
		
		if ($players_online < $player_minimum) {
			send_chat($from,$id,"There are not enough players online to start a bountyhunt! ");
		} else {
			my $bounty_start_money = $start_money * $players_online;
			
			if ($startbounty ne "") {
				if (int($startbounty) >= $bounty_start_money) {
					$bounty_start_money = int($startbounty);
				} else {
					send_chat($from,$id,"Your custom start bounty is too low! ");
					return ();
				}
			} 
			
			print $conn "getcash $from\n";
			my $line = &readWithTimeout(2,"cash=");
			chop($line);chop($line);
			if (defined $line and $line=~ m/^cash=(.*)$/ and $1 > $bounty_start_money) {
				
				## last preparations
				print $conn "getplayerinfo $from\n";
				my $line2 = &readWithTimeout(2,"charname=");
				chop($line2);chop($line2);
				if (defined $line2 and $line2=~ m/^charname=.*clientid=($id) ip=.*base=(.*) last_base=.*$/) {
					my $system_of_player = substr($2,0,4);
					$target_system = calc_target_system($system_of_player);
					
					## now start the hunt!
					if (defined $system_of_player and $system_of_player ne "") {
						if (!defined $target_system) {
							send_chat($from,$id,"Error! (Please report this problem in the forums) ");
						} else {
						print $conn "addcash $from -$bounty_start_money\n";
						my $spamline = &readWithTimeout(2,"OK");
						my $system_read = get_sys_readable($target_system);
						send_chat("","","Bountyhunt!   $from is heading to the ".get_region($target_system)." systems - Kill him/her and deliver the escape pod to get a reward of $bounty_start_money Credits! ");
						send_chat($from,$id,"$bounty_start_money Credits have been removed from your char. To win this bountyhunt dock at any base in the $system_read System! ");
						$bountyhunt_last = time();
						$bountyhunt_started = time();
						$system_change = time();
						$last_umsg = time();
						$bountyhunt_hunted = $from;
						$bountyhunt_bounty = $bounty_start_money;
						$bountyhunt_increased = time();
						$last_loggedincheck = time();
						$current_system = $system_of_player;
						}
					} else {
						send_chat($from,$id,"You need to be docked at a base to start a bountyhunt! ");
					}
				}
			} else {
				send_chat($from,$id,"You have not enough money to pay the starting bounty! (You need $bounty_start_money Credits) ");
			}
		}		
	}	
}

sub get_region {
	my ($system) = @_;
	
	my $system = substr($system,0,4);
	
	if (lc(substr($system,0,2)) eq "iw") {
		return "Independent";
	}
	
	if (lc(substr($system,0,2)) eq "rh") {
		return "Rheinland";
	}
	if (lc(substr($system,0,2)) eq "li") {
		return "Liberty";
	}
	if (lc(substr($system,0,2)) eq "br") {
		return "Bretonia";
	}
	if (lc(substr($system,0,2)) eq "ku") {
		return "Kusari";
	}
	if (lc(substr($system,0,2)) eq "hi") {
		return "Omicron";
	}
	if (lc($system) eq "ew01") {
		return "Tau";
	}	elsif (lc(substr($system,0,2)) eq "ew") {
		return "Omikron";
	}
	if (lc(substr($system,0,2)) eq "bw" and substr($system,2,2) < 5) {
		return "Omega";
	}
	if (lc(substr($system,0,2)) eq "bw" and substr($system,2,2) > 4 and substr($system,2,2) < 8) {
		return "Sigma";
	}
	if (lc(substr($system,0,2)) eq "bw" and substr($system,2,2) > 7) {
		return "Tau";
	}
	
}

sub calc_target_system {
	my ($system_origin) = @_;
	
	my @system_array = ();
	my $system_counter = 0;
	
	if (open(SYSTEMPATHSFILE,"<$systempaths_file")) {
		while (<SYSTEMPATHSFILE>) {
			my $line = $_;
			chomp($line); #newline wegschneiden
			if ($line =~ m/^Path = ($system_origin),.*$/ and length($line) > 57) {
				my $system_target = substr($line, 13, 4);
				if ($system_target ne "Ew05" and $system_target ne "Ew06" and $system_target ne "Li01" and lc(substr($system_target,0,2)) ne "iw") { ## Ausnahmen!
					$system_array[$system_counter] = $system_target;
					$system_counter++;
				}
			}
		}		
		close(SYSTEMPATHSFILE);
		
		my $random_number = int(rand($system_counter));
		
		if ($system_counter > 0) {		
			return $system_array[$random_number];
		} else {
			return ();
		}
		
	} else {
		return ();
	}
	
}

sub calc_target_system_near {
	my ($system_origin) = @_;
	
	my @system_array = ();
	my $system_counter = 0;
	
	if (open(SYSTEMPATHSFILE,"<$systempaths_file")) {
		while (<SYSTEMPATHSFILE>) {
			my $line = $_;
			chomp($line); #newline wegschneiden
			if ($line =~ m/^Path = ($system_origin),.*$/ and length($line) > 33) {
				my $system_target = substr($line, 13, 4);
				if ($system_target ne "Ew05" and $system_target ne "Ew06" and $system_target ne "Li01" and lc(substr($system_target,0,2)) ne "iw") { ## Ausnahmen!
					$system_array[$system_counter] = $system_target;
					$system_counter++;
				}
			}
		}		
		close(SYSTEMPATHSFILE);
		
		my $random_number = int(rand($system_counter));
		
		if ($system_counter > 0) {		
			return $system_array[$random_number];
		} else {
			return ();
		}
		
	} else {
		return ();
	}
	
}

sub get_sys_readable {
	my ($system_nick) = @_;
	
	&connectdb();
	my $sql_system_name = "SELECT sy_longtext FROM $flsystem_table_name WHERE sy_kuerzel = ".$dbh->quote($system_nick);
  $sth = $dbh->prepare( $sql_system_name );
  $sth->execute();
	my @result=$sth->fetchrow_array;
	$sth->finish();
	
	return $result[0];
	
}

sub get_players_on {
	
	my $counter = 0;

	print $conn "getplayers\n";
		my $line= undef;
    my $starttime = time();
    while ( (time() - $starttime) < 10 )
    {
        $line = <$conn>;
        if ( defined $line ) {
        	chop($line);chop($line);
        	if ($line eq "OK") {
        		last;
        	} elsif ($line=~ m/^charname=.*/) {
        		$counter++;
        	}
        }
        #100 ticks per sec
        select(undef,undef,undef,0.01);
    }
    
   return $counter;
	
	
}


sub bountyhunt_stale {
	
	$bountyhunt_stale = $current_system;
	$bountyhunt_stale_time = time();
	
	$bountyhunt_changes--;
	
	send_chat("","","Bountyhunt: Hunt interrupted. Dock at any base in the ".get_sys_readable($current_system)." system and type \"/bountyhunt takeover\" to take over the bounty! ");
	
	if($current_system eq $target_system) {
		$target_system = calc_target_system_near($current_system);
		send_chat("","","Bountyhunt: The target system has been changed to ".get_sys_readable($target_system)."! ");
	}
	
}

sub bountyhunt_takeover {
	my ($from,$id) = @_;
	
	if($from eq $bountyhunt_hunted) {
		send_chat($from,$id,"You cannot take over your own hunt! ");
	} elsif(defined $bountyhunt_stale) {
		
		## last preparations
		print $conn "getplayerinfo $from\n";
		my $line = &readWithTimeout(2,"charname=");
		chop($line);chop($line);
		if (defined $line and $line=~ m/^charname=.*clientid=($id) ip=.*base=(.*) last_base=.*$/) {
			my $system_of_player = substr($2,0,4);
			if($system_of_player eq $bountyhunt_stale) {
				$bountyhunt_stale = undef;
				$bountyhunt_stale_time = undef;
				change_bountyhunt($from);
				if(defined $bountyhunt_started) {
					send_chat("","","Bountyhunt: ".$bountyhunt_hunted." took over the bounty - kill him/her and steal the Escape Pod to get a reward of $bountyhunt_bounty Credits! ");
				}
			} else {
				send_chat($from,$id,"You need to dock at any base in the ".get_sys_readable($current_system)." system to take over the bounty! ");
			}
		}		
	} else {
		send_chat($from,$id,"You cannot take over the bounty at the moment");		
	}
	
}



sub handle_chat {
	my ($from,$id,$type,$text) = @_;
	
	if ($text =~ m/^\/bountyhunt start/i && $bountyhunt_activated == 1) {
		
		if (!defined $bountyhunt_stale and !defined $bountyhunt_started) {
			my $startbounty = substr($text,18);
			&reload_config();
			&start_bountyhunt($from,$id,$startbounty);
		} else {
			send_chat($from,$id,"Sorry, a bountyhunt is already in progress! ");
		}
		
	}
	
	if ($text =~ m/^\/bountyhunt deactivate 1337/i) {
		
		if (defined $bountyhunt_started){
			send_chat("","","Bountyhunt has been aborted. Reason: Script deactivated! ");
			&abort_bountyhunt();
		}
		$bountyhunt_activated = 0;		
	}
	
	if ($text =~ m/^\/bountyhunt activate 1337/i) {
		$bountyhunt_activated = 1;				
	}
	
	if ($text =~ m/^\/bountyhunt takeover/i) {
		if(defined $bountyhunt_started && $bountyhunt_activated == 1) {
			&bountyhunt_takeover($from,$id);
		} else {
			send_chat($from,$id,"No bountyhunt active. ");
		}
	}
	
	if (($text =~ m/^\/bountyhunt help/i) && $bountyhunt_activated == 1) {
		send_chat($from,$id,"To start a new bountyhunt just type \"/bountyhunt start\" ");
		send_chat($from,$id,"This will place a bounty on your head and you will have to dock at any base in a given system. ");
		send_chat($from,$id,"The starting bounty is charged off your own credits and depends on how many players are on the server! ");
		send_chat($from,$id,"You can set up a higher starting bounty by typing \"/bountyhunt start [Credits]\". ");
		send_chat($from,$id,"The more players are online, the more the bounty will be increased during the hunt. ");
		send_chat($from,$id,"If you win the hunt by docking at any base in the target system, you will receive the current bounty. ");
		send_chat($from,$id,"You cannot start a bounty if there are less than $player_minimum players on the server. ");
		send_chat($from,$id,"You are not allowed to stay in a system for more than $max_system_time minutes! ");
		send_chat($from,$id,"Starting Bounty is: Players online * $start_money  Bountyhunt Time Limit is: $bounty_time_limit minutes ");
		
	}
	
	if ((lc($text) eq "/bountyhunt") && $bountyhunt_activated == 1) {
		if (defined $bountyhunt_started) {
			my $minutes_left = round($bounty_time_limit - ((time() - $bountyhunt_started)/60));
			if(defined $bountyhunt_stale) {
				send_chat($from,$id,"Bountyhunt is interrupted. Dock at any base in the ".get_sys_readable($bountyhunt_stale)." system and type \"/bountyhunt takeover\" to take over the bounty!" );
			} elsif ($from eq $bountyhunt_hunted) {
				send_chat($from,$id,"Current Bounty: $bountyhunt_bounty Credits - Target System: ".get_sys_readable($target_system)." - Time Left: $minutes_left minutes ");
			} else {
				send_chat($from,$id,"Currently hunted: $bountyhunt_hunted - Current Bounty: $bountyhunt_bounty Credits - Target Region: ".get_region($target_system)." - Time Left: $minutes_left minutes ");
			}
		} else {
			send_chat($from,$id,"There is nobody hunted at the moment. ");
		}
		
		send_chat($from,$id,"To get help about bountyhunt please type \"/bountyhunt help\" ");
	}
	
}


sub reload_config {
	
	$cfg = Config::IniFiles->new( -file => 'bountyhunt.ini' );
	
$bounty_time_limit = $cfg->val('Bountyhunt', 'bounty_time_limit');
$umsg_interval = $cfg->val('Bountyhunt', 'umsg_interval');
$start_money = $cfg->val('Bountyhunt', 'start_money');
$player_minimum = $cfg->val('Bountyhunt', 'player_minimum');
$bountyblock_time = $cfg->val('Bountyhunt', 'bountyblock_time');
$reward_increase = $cfg->val('Bountyhunt', 'reward_increase');
$reward_interval = $cfg->val('Bountyhunt', 'reward_interval');
$max_system_time = $cfg->val('Bountyhunt', 'max_system_time');
$crash_timelimit = $cfg->val('Bountyhunt', 'crash_timelimit');
$stale_timelimit = $cfg->val('Bountyhunt', 'stale_timelimit');
$bounty_changes_limit = $cfg->val('Bountyhunt', 'bounty_changes_limit');
$loggedin_check_interval = $cfg->val('Bountyhunt', 'loggedin_check_interval');
$systempaths_file = $cfg->val('Bountyhunt', 'systempaths_file');
	
}



####################################################################

sub handle {
    my $line = shift;

		chop($line);chop($line);
		
		#baseenter char=Totenwchter id=5 base=Li01_13_Base system=Li01

    if ( $line =~ m/^chat from=(.*) id=(.*) type=(.*) text=(.*)$/) {
    	
    	&handle_chat($1,$2,$3,$4);
    	
    } elsif (!defined $bountyhunt_stale and defined $bountyhunt_started and $line =~ m/^login char=(.*) accountdirname=.*$/)  {
    	
    	if ($bountyhunt_hunted eq $1) {
    		if (defined $server_crashed) {
    			$server_crashed = undef;
    			$system_change = time();
    			$system_change_warned = 0;
    		} else {
#    			send_chat("","","Bountyhunt has been aborted. Reason: Hunted F1! ");
					&bountyhunt_stale();
				}
    	}
    	
    } elsif (!defined $bountyhunt_stale and defined $bountyhunt_started and $line =~ m/^kill victim=(.*) type=.*$/ and $1 eq $bountyhunt_hunted) {
    	
    	if ($line =~ m/^kill victim=(.*) type=(.*) by=(.*)$/) {
    		send_chat("","",$bountyhunt_hunted." has been killed! ".$3." got the Escape Pod - kill him/her and steal the Escape Pod to get a reward of $bountyhunt_bounty Credits! ");
    		&change_bountyhunt($3);
    	} else {
#    		send_chat("","","Bountyhunt has been aborted. Reason: Hunted died and we have no killer! ");
				&bountyhunt_stale();
    	}
    	
    } elsif (!defined $bountyhunt_stale and defined $bountyhunt_started and $line =~ m/^baseenter char=(.*) id=.*system=(.*)$/ and $1 eq $bountyhunt_hunted and $2 eq $target_system) {
    	
    	if ($bountyhunt_changes > 0) {
    		send_chat("","","Bountyhunt has been finished. The Escape Pod has been delivered and ".$bountyhunt_hunted." will now receive $bountyhunt_bounty Credits! ");
    	} else {
    		send_chat("","","Bountyhunt has been finished. The Hunted escaped and ".$bountyhunt_hunted." will now receive $bountyhunt_bounty Credits! ");
    	}
    	&end_bountyhunt();
    } elsif (!defined $bountyhunt_stale and defined $bountyhunt_started and $line =~ m/^jumpin char=(.*) id=.* system=(.*)$/) {
    	if ($bountyhunt_hunted eq $1) {
    		$current_system = $2;
    		$system_change = time();
    		$system_change_warned = 0;
    		if ($target_system eq $current_system) {
    			send_chat("","","Bountyhunt: ".$bountyhunt_hunted." reached the Target System! Kill the Hunted now!!! ");
    		}
    	}    	
    }

    
    

}
